% Realiza o calculo da fase transformada de hilbert dado a magnitude e
% frequencia

function fase_estimada = Hilbert_mag_phase(modulo,frequencia,fase,MAXPONTOS,inv)
%% Criacao de vetores iniciais
linhas = MAXPONTOS;
alfa = zeros(MAXPONTOS,1);
omega =  zeros(MAXPONTOS,1);
integral = zeros(MAXPONTOS,1);

%% Conversao de modulo para nepers e frequencia para rad/s
%maximo = -1e50;
for i=1:linhas 
    alfa(i,1) = log(modulo(i,1));% - log(modulo(1,1)); %Subtrai o primeiro ponto. Deveria subtrair o maximo, parece.
    omega(i,1) = 2*pi*frequencia(i,1);
   % if (alfa(i,1) > maximo)
   %     maximo = alfa(i,1);
   % end
end

%% Calculo da fase estimada
% Para cada omega[i]
for i=1:linhas 
    
    integral(i,1)=0;
    for j=2:linhas 
        d1=omega(i,1)*omega(i,1) - omega(j-1,1)*omega(j-1,1);
        d2=omega(i,1)*omega(i,1) - omega(j,1)*omega(j,1);   
        if (d1==0 || d2==0)
        else
            integral(i,1) = integral(i,1) + (alfa(j,1)/d2 + alfa(j-1,1)/d1)/2*(omega(j,1)-omega(j-1,1)); %//Soma trapzios
        end
    end

    % Passo duplo em torno da singularidade
    if (i>1 && i<linhas) 
        d1=omega(i,1)*omega(i,1)-omega(i-1,1)*omega(i-1,1);
        d2=omega(i,1)*omega(i,1)-omega(i+1,1)*omega(i+1,1);
        integral(i,1) = integral(i,1)+(alfa(i-1,1)/d1 + alfa(i+1,1)/d2)/2*(omega(i+1,1)-omega(i-1,1));
    end

    %Soma 180 graus se passar de -180 graus. Deveria generalizar para manter entre +/- 180 graus
    integral(i,1) = integral(i,1)*(-2*omega(i,1)/pi);
    
    %Inversao de fase
    if(inv) 
        integral(i,1) = integral(i,1) + pi;
    end
    
    if (integral(i,1)<-pi) 
      integral(i,1)= integral(i,1)+2*pi;
    else if (integral(i,1)>pi)
             integral(i,1)= integral(i,1)-2*pi;
        end
    end
    if (fase(i,1)<-180) 
		  fase(i,1) = fase(i,1) + 360; %% Idem para a fase padro
    else if (fase(i,1)>180) 
		  fase(i,1) = fase(i,1) - 360;
        end
    end
    
end
  
%% Conversao para graus
fase_estimada = integral*180/pi;


