% Transformada de Hilbert - Fase a partir da Magnitude

clear all; close all; clc;

% Especifica se deseja ou nao usar uma GUI para selecao do arquivo
usar_GUI = true; 

%% ******* Controle do arquivo de entrada *******

% Existencia do arquivo de entrada
arquivo = fileRequest(usar_GUI);

% Controle do numero de elementos do arquivo de entrada
file_size = size(load(arquivo));
while(file_size(2) < 4)
    disp('O arquivo de entrada no possui todos os elementos necessrios');
    fprintf('O arquivo deve ser organizado em 4 colunas sendo:\n\tFrequncia\tMagnitude\tFase\tFase calculada\n')
    fprintf('\t...\t\t\t...\t\t\t...\t\t...\n')
    fprintf('\t...\t\t\t...\t\t\t...\t\t...\n')
    arquivo = fileRequest(usar_GUI);
    file_size = size(load(arquivo));
end

% Modulo em SPL
SPL_char = upper(input('Deseja plotar a magnitude do arquivo em Sound Pressure Level [Y/N]? ','s'));
while((~(strcmp(SPL_char,'Y'))) && (~(strcmp(SPL_char,'N'))))
    disp('Opcao invalida')
    SPL_char = upper(input('Deseja plotar a magnitude do arquivo em Sound Pressure Level [Y/N]? ','s'));
end
if (strcmp(SPL_char,'Y'))
    SPL = 1;
else
    SPL = 0;
end

% Inversao de fase
inv_char = upper(input('Deseja inverter a fase calculada [Y/N]? ','s'));
while((~(strcmp(inv_char,'Y'))) && (~(strcmp(inv_char,'N'))))
    disp('Opcao invalida')
    inv_char = upper(input('Deseja inverter a fase calculada [Y/N]? ','s'));
end
if (strcmp(inv_char,'Y'))
    inv = 1;
else
    inv = 0;
end

% Limite do range de frequencias
freq_char = upper(input('Deseja especificar o range das frequncias nos graficos [Y/N]? ','s'));
while((~(strcmp(inv_char,'Y'))) && (~(strcmp(inv_char,'N'))))
    disp('Opcao invalida')
    freq_char = upper(input('Deseja inverter a fase calculada [Y/N]? ','s'));
end
if (strcmp(freq_char,'Y'))
    f1 = input('Limite minimo de frequncia: ');
    f2 = input('Limite maximo de frequncia: ');
end

%% ******* Processamento *******

% Carrega arquivos de frequencia, modulo e fase
txt_file = load(arquivo);
freq = txt_file(:,1);
mag = txt_file(:,2);
fase = txt_file(:,3);
fase_estimada_original = txt_file(:,4);

% Define o numero maximo de pontos
MAXPONTOS = length(freq);

% Realiza o calculo da fase
fase_estimada = Hilbert_mag_phase(mag,freq,fase,MAXPONTOS,inv);

% Pressao referencia para SPL
if (SPL)
    p0 = 20e-6;
else
    p0 = 1;
end

%% ******* Saida *******

% Magnitude
figure()
semilogx(freq,20*log10(abs(mag)/p0))
if (SPL)
    title('Magnitude em SPL')
else
    title('Magnitude [dB] do sinal de entrada')
end
grid on
if (strcmp(freq_char,'Y'))
    xlim([f1 f2])
end

% Fase Calculada do arquivo x Fase Calculada MATLAB
figure();
semilogx(freq,fase_estimada_original,freq,fase_estimada,'r');
title('Fase estimada arquivo x Fase calculada')
grid on
if (strcmp(freq_char,'Y'))
    xlim([f1 f2])
    ylim([-200 200])
end

% Fase x Fase Calculada do arquivo
figure();
semilogx(freq,fase,freq,fase_estimada_original,'r');
title('Fase x Fase estimada arquivo')
grid on
if (strcmp(freq_char,'Y'))
    xlim([f1 f2])
    ylim([-200 200])
end

% Fase x Fase Calculada MATLAB
figure()
semilogx(freq,fase,freq,fase_estimada,'r');
title('Fase x Fase calculada')
grid on
if (strcmp(freq_char,'Y'))
    xlim([f1 f2])
    ylim([-200 200])
end


